//+------------------------------------------------------------------+
//|                                              GlobalVariables.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
// TakeProfit, StopLoss  Stop_0   4-  ,   5- ,     
//      10.
//+------------------------------------------------------------------+
// pass = 1       (2 + 3)( ) -   TakeProfit  StopLoss  Stop_0,
//                                       2                  -   MA_Fast_TimeInt2, MA_Slow_TimeInt2
// pass = 2         3                  -   MA_Fast_TimeInt3, MA_Slow_TimeInt3
// pass = 3         (MA_Fast_TimeInt2, MA_Slow_TimeInt2)   (MA_Fast_TimeInt3, MA_Slow_TimeInt3) 
//                          
extern int    pass = 3;

extern bool   TradeAllowed = true; //   ,  TradeAllowed = false,    ,
                                   //       -     ,
                                   // ,     .
                                   //   TradeAllowed = false,   ,     .
extern int    MagicNumber = 0;    //            ,    
extern double LotInitial  = 0.01;  //        

// TakeProfit,StopLoss, Stop_0     4-  ,   5- ,     
//      10.
extern int    MA_Fast_TimeInt2    = 7;   //  
extern int    MA_Slow_TimeInt2    = 14;  //  

extern int    MA_Fast_TimeInt3    = 7;  //  
extern int    MA_Slow_TimeInt3    = 14;  //  

int           MA_Fast;
int           MA_Slow;

extern int    TakeProfit  = 50;  // 4-  
extern int    StopLoss    = 50;  // 4-  
//  !     Stop_0,  Stop_0_Zero     
extern int    Stop_0      = 30;  // 4-  ,            -   .
                                 //  Stoplevel    ,      .
                                 //  Stop_0 = 0,      StopLoss-    .
int           Stoplevel;          //     Stoplevel = MarketInfo(Symbol(),MODE_STOPLEVE)   

static bool     BUY_Sign  = false;
static bool     BUY_Stop  = false;
static bool     SELL_Sign = false;
static bool     SELL_Stop = false;

static datetime LastBar = 0;

int _ExpertOrdersTotal;    //  ,  
int _ExpertOrdersBuy;     
int _ExpertOrdersSell;     
int _ExpertOrdersBuyStop;    
int _ExpertOrdersSellStop;     
int _ExpertOrdersBuyLimit;    
int _ExpertOrdersSellLimit;     

// ,           :
int      _OrderTicket[], _OrderType[];
double   _OrderLots[], _OrderOpenPrice[], _OrderStopLoss[], _OrderTakeProfit[];
double   _OrderProfit[], _OrderSwap[], _OrderCommission[];
datetime _OrderOpenTime[], _OrderExpiration[];
string   _OrderComment[];
int      _OrderMagicNumber[];

color   Order_Clr;
#define ORDER_BUY_CLR  Blue 
#define ORDER_SELL_CLR Red

string OrderOpenSetOkMes           = "  - / "; 
string OrderOpenSetErrorMes        = "  -  /"; 
string OrderOpenStoplevel_ErrorMes = "  -  : StopLoss/TakeProfit   Stoplevel=";
string OrderOpenLotValue_ErrorMes  = "  -  :      ";

string OrderModifyOkMes            = "  -  ";   
string OrderModifyErrorMes         = "  -   "; 
string OrderModifyStop_0_ErrorMes  = "  -   : Stop_0   Stoplevel="; 

string OrderCloseOkMes        = "  -  "; 
string OrderCloseErrorMes     = "  -   "; 

string ParmsOKReadyMes="   ,      - TradeAllowed = true";
string ParmsOKNotReadyMes="   , ,        - TradeAllowed = false";


int TradeDirection;
int LastError;
int i;
// end of GlobalVariables
//+------------------------------------------------------------------+
//|                                                  SetSignales.mq4 |
//|                                         Copyright  2010, "more" |
//|                                      "mailto:tradertobe@gmail.co |
//+------------------------------------------------------------------+
//************************************************************          
void T_SetSignales(bool& BUY_Sign, bool& BUY_Stop, bool& SELL_Sign, bool& SELL_Stop, int& LastBar )  
  {      
   datetime IBARS = iTime(NULL,0,0);
   if (LastBar == IBARS)  return; //  
//---  
//   ...   
   LastBar  = IBARS;     //      SetFractalsValue();
//---  
   BUY_Sign  = false;
   BUY_Stop  = false;
   SELL_Sign = false;
   SELL_Stop = false;
   
   double ba1 = iMA(NULL,0,MA_Fast,0,MODE_SMA,PRICE_MEDIAN,1) - iMA(NULL,0,MA_Slow,0,MODE_SMA,PRICE_MEDIAN,1);
   double ba2 = iMA(NULL,0,MA_Fast,0,MODE_SMA,PRICE_MEDIAN,2) - iMA(NULL,0,MA_Slow,0,MODE_SMA,PRICE_MEDIAN,2);

   if (ba1 > 0 && ba2 <0) {BUY_Sign  = true;  SELL_Stop = true;}
   if (ba1 < 0 && ba2 >0) {SELL_Sign = true;  BUY_Stop  = true;}
    
   return;  
  } // end of void SetSignales ()       
//************************************************************          

//+------------------------------------------------------------------+
//|                                                  OrdersOpen.mq4  |
//|                                      Copyright  2010, "more"    |
//|                                     "mailto:tradertobe@gmail.com |
//+------------------------------------------------------------------+
//+---------------------------------------------------------------------------------------------------------------+
//|                                                                                         |
//+---------------------------------------------------------------------------------------------------------------+
bool T_OrdersOpen(bool& BUY_Sign, bool& SELL_Sign)   // return(true) -         
{                                      // return(false)-     ,        start()
    if (!BUY_Sign && !SELL_Sign) return(false);
    if (_ExpertOrdersTotal !=0 ) return(false);
//----
    if (TradeAllowed)  
     {
       Stoplevel = MarketInfo(Symbol(),MODE_STOPLEVEL);
       if ((StopLoss != 0 && StopLoss < Stoplevel) || (TakeProfit != 0 && TakeProfit < Stoplevel))
       {
        PlaySound("alert.wav");
        Print(OrderOpenStoplevel_ErrorMes+Stoplevel);
        return(false);
       } // if ((StopLoss != 0 && StopLoss < Stoplevel) || (TakeProfit != 0 && TakeProfit < Stoplevel))
       TradeDirection = iif(BUY_Sign,+1,-1);
       i = 0; //  
       _OrderType       [i] = iif(TradeDirection < 0,OP_SELL,OP_BUY);
       double LotValue = 0;     
       if (!T_GetLotValue(Symbol(),_OrderType[i],LotValue)) 
       {
        PlaySound("alert.wav");
        Print(OrderOpenLotValue_ErrorMes);
        return(false);
       }
       RefreshRates();
       TradeDirection = iif(BUY_Sign,+1,-1);
      _OrderType       [i] = iif(TradeDirection < 0,OP_SELL,OP_BUY);
      _OrderLots       [i] = LotValue;
      _OrderOpenPrice  [i] = iif(_OrderType[i]==OP_BUY,Ask,Bid);

      _OrderStopLoss  [i] = iif(_OrderType[i]==OP_BUY,_OrderOpenPrice[i] - StopLoss * Point,_OrderOpenPrice[i] + StopLoss * Point);
      _OrderStopLoss  [i] = iif( _OrderStopLoss[i]==_OrderOpenPrice[i],0,_OrderStopLoss[i]);

      _OrderTakeProfit[i] = iif(_OrderType[i]==OP_BUY,_OrderOpenPrice[i] + TakeProfit*Point,_OrderOpenPrice[i] - TakeProfit*Point);
      _OrderTakeProfit[i] = iif(_OrderTakeProfit[i] == _OrderOpenPrice[i],0,_OrderTakeProfit[i]);

      _OrderMagicNumber[i] = MagicNumber;
      _OrderComment    [i] = " "; 
      Order_Clr            = iif(TradeDirection > 0,ORDER_BUY_CLR,ORDER_SELL_CLR);  
      bool temp = false;
      if (_OrderSend())
      {
       BUY_Sign  = iif(TradeDirection == +1,false,BUY_Sign ); 
       SELL_Sign = iif(TradeDirection == -1,false,SELL_Sign); 
       temp = true;
      }
      return(temp);
     } // if (TradeAllowed)
 //----
    return(false); //     ,        start()
} // bool OrdersOpen(bool& BUY_Sign, bool& SELL_Sign)
//+---------------------------------------------------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|               |
//|                       |
//+------------------------------------------------------------------+
bool _OrderSend()
  {
   if (IsTradeContextBusy()) { PlaySound("alert.wav"); return(false);} //   ,   
   _OrderTicket[i]=  
        OrderSend(Symbol(),_OrderType       [i]
                          ,_OrderLots       [i]
                          ,_OrderOpenPrice  [i] ,3
                          ,_OrderStopLoss   [i]
                          ,_OrderTakeProfit [i]
                          ,_OrderComment    [i]
                          ,_OrderMagicNumber[i],0,Order_Clr);
   if (_OrderTicket[i] < 0)
    {
     LastError = GetLastError();
     Print("("+_OrderMagicNumber[i]+")"+_OrderComment[i]+OrderOpenSetErrorMes+" : "+ LastError+" - "+ErrorDescription(LastError));
     PlaySound("alert.wav");
     return(false);
    }
   Print("("+_OrderMagicNumber[i]+")"+_OrderComment[i]+"("+_OrderTicket[i]+")"+OrderOpenSetOkMes);
   PlaySound("ok.wav");
   return(true);
}    // end of bool _OrderSend()  
//+---------------------------------------------------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                  OrdersClose.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
//+----------------------------------------------------------------------------------------------------------------------+
//|       BUY  |    SELL
//+----------------------------------------------------------------------------------------------------------------------+
bool T_OrdersClose(bool& BUY_Stop, bool& SELL_Stop )   // return(true) -         
{                  // return(false)-     ,        start()
    if (!BUY_Stop && !SELL_Stop)             return(false);
    if (_ExpertOrdersTotal == 0)             return(false);
    i = 0;
    RefreshRates();
    TradeDirection = iif(BUY_Stop,+1,-1);
    _OrderOpenPrice  [i] = iif(TradeDirection == +1,Bid,Ask);
    Order_Clr            = iif(TradeDirection > 0,ORDER_BUY_CLR,ORDER_SELL_CLR);  
    bool temp = false;
    if (_OrderClose())
    {
     BUY_Sign  = iif(TradeDirection == +1,false,BUY_Sign ); 
     SELL_Sign = iif(TradeDirection == -1,false,SELL_Sign); 
     temp = true;
    }
    return(temp);
}  // end of if ( (BUY_Stop && _ExpertOrdersBuy  != 0) ||  (SELL_Stop && _ExpertOrdersSell != 0))
 //+--------------------------------------------------------------------+
//|                 |
//|                                             |
//+--------------------------------------------------------------------+
bool _OrderClose()
  {
   if (IsTradeContextBusy()) { PlaySound("alert.wav"); return(false);} //   ,   
   if (OrderClose(_OrderTicket   [i]
                 ,_OrderLots     [i]
                 ,_OrderOpenPrice[i],3
                 ,Order_Clr))
    {
     Print("("+_OrderMagicNumber[i]+")"+_OrderComment[i]+"("+_OrderTicket[i]+")"+OrderCloseOkMes);
     PlaySound("ok.wav");
     return(true);
    }
     LastError = GetLastError();  
     Print("("+_OrderMagicNumber[i]+")"+_OrderComment[i]+"("+_OrderTicket[i]+")"+OrderCloseErrorMes+" : "+ LastError+" - "+ErrorDescription(LastError));
     PlaySound("alert.wav");
     return(false);
  }  // end of bool _OrderClose()
//************************************************************************************************************************************
//+------------------------------------------------------------------+
//|                                                 OrdersModify.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
//+---------------------------------------------------------------------------------------+
//|           |
//+---------------------------------------------------------------------------------------+
bool T_OrdersModify()    // return(true) -         
{                      // return(false)-     ,        start()
    if (_ExpertOrdersTotal == 0) return(false);
    RefreshRates();
//   Stop_0 != 0,  -     
    if (Stop_0 != 0) 
    {
     for (i = 0; i < _ExpertOrdersTotal; i++)
     {    
      TradeDirection = iif(_OrderType[i] == OP_BUY,+1,-1);
      double CurrentPrice = iif(TradeDirection == +1,Bid,Ask);
      int ProfitPips = iif(TradeDirection == +1,(CurrentPrice - _OrderOpenPrice[i])/Point,(_OrderOpenPrice[i] - CurrentPrice)/Point);
      if (ProfitPips < Stop_0)     continue;
      Stoplevel = MarketInfo(Symbol(),MODE_STOPLEVEL);
      if (Stop_0 <= Stoplevel)
      {
       PlaySound("alert.wav");
       Print("("+MagicNumber+")"+_OrderComment[i]+"("+_OrderTicket[i]+")"+OrderModifyStop_0_ErrorMes+Stoplevel);
       continue;
      }
      if (_OrderStopLoss  [i] == _OrderOpenPrice [i]) continue;
      _OrderStopLoss  [i] = _OrderOpenPrice [i]; 
      bool temp = _OrderModify();
      break;
     } // for (i = 0; i < _ExpertOrdersTotal; i++)
     return(temp); 
    } // if (Stop_0 != 0) 
} // end of bool OrdersModify()
//+--------------------------------------------------------------------+
//|                 |
//|                              |
//+--------------------------------------------------------------------+
bool _OrderModify()
  {
   if (IsTradeContextBusy()) { PlaySound("alert.wav"); return(false);} //   ,   
   if (OrderModify(_OrderTicket    [i]
                  ,_OrderOpenPrice [i]
                  ,_OrderStopLoss  [i]
                  ,_OrderTakeProfit[i]
                  ,0
                  ,CLR_NONE))
    {
     Print("("+MagicNumber+")"+_OrderComment[i]+"("+_OrderTicket[i]+")"+OrderModifyOkMes);
     PlaySound("ok.wav");
     return(true);
    }
     LastError = GetLastError(); if (LastError == ERR_NO_RESULT) return(true);
     Print("("+MagicNumber+")"+_OrderComment[i]+"("+_OrderTicket[i]+")"+OrderModifyErrorMes+" : "+ LastError+" - "+ErrorDescription(LastError));
     PlaySound("alert.wav");
     return(false);
  }  // end of bool _OrderModify() 
//+---------------------------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                  GetLotValue.mq4 |
//|                                         Copyright  2010, "more" |
//|                                      "mailto:tradertobe@gmail.co |
//+------------------------------------------------------------------+
bool T_GetLotValue(string symbol, int Cmd, double& Lot)
 {
   Lot = LotInitial;
   double MINLOT = MarketInfo(symbol, MODE_MINLOT);
   if (MINLOT == 0) return(false);
   if (Lot < MINLOT) Lot = MINLOT;
   double LOTSTEP = MarketInfo(symbol, MODE_LOTSTEP);
   if (LOTSTEP == 0)  return(false);
   Lot = LOTSTEP * MathFloor(Lot / LOTSTEP); 
   if (AccountFreeMarginCheck(symbol, Cmd, Lot) >= 0) return(true);
   else return(false);
//---
 }  // bool GetLotValue(string symbol, int Cmd, double& Lot)
//********************************************************************************************************************
//+------------------------------------------------------------------+
//|                                                AllOrdersInit.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
 //|     ,                           |
//|  ,  .  ,                     |
//|     .             |
//|   =  _ExpertOrdersTotal + 1                                                      |
//|           /|
//|                                                                                         |
 //+----------------------------------------------------------------------------------------------------+
//"mailto:komposterius@mail.ru" -   -   
//http://www.mql4.com/ru/users/komposter  
void T_AllOrdersInit( int magic )
{
	int _GetLastError = 0, _OrdersTotal = OrdersTotal();
    _ExpertOrdersTotal     = 0;    //  ,  
    _ExpertOrdersBuy       = 0;    // 
    _ExpertOrdersSell      = 0;    // 
    _ExpertOrdersBuyStop   = 0;    // 
    _ExpertOrdersSellStop  = 0;    // 
    _ExpertOrdersBuyLimit  = 0;    // 
    _ExpertOrdersSellLimit = 0;    // 
 	//      - 
	// ( _OrdersTotal = 0,     1) 
	int temp_value = MathMax( _OrdersTotal+1, 1 );
	ArrayResize( _OrderTicket,			temp_value );
	ArrayResize( _OrderType,			temp_value );
	ArrayResize( _OrderLots,			temp_value );
	ArrayResize( _OrderOpenPrice,		temp_value );
	ArrayResize( _OrderStopLoss,		temp_value );
	ArrayResize( _OrderTakeProfit,	temp_value );
	ArrayResize( _OrderOpenTime,		temp_value );
	ArrayResize( _OrderProfit,			temp_value );
	ArrayResize( _OrderSwap,			temp_value );
	ArrayResize( _OrderCommission,	temp_value );
	ArrayResize( _OrderComment,		temp_value );
	ArrayResize( _OrderExpiration,	temp_value );
	ArrayResize( _OrderMagicNumber,	temp_value );
	

	//  
	ArrayInitialize( _OrderTicket,		0 );    
	ArrayInitialize( _OrderType,			0 );
	ArrayInitialize( _OrderLots,			0 );
	ArrayInitialize( _OrderOpenPrice,	0 );
	ArrayInitialize( _OrderStopLoss,		0 );
	ArrayInitialize( _OrderTakeProfit,	0 );
	ArrayInitialize( _OrderOpenTime,		0 );
	ArrayInitialize( _OrderProfit,		0 );
	ArrayInitialize( _OrderSwap,			0 );
	ArrayInitialize( _OrderCommission,	0 );
	ArrayInitialize( _OrderExpiration,	0 );
	ArrayInitialize( _OrderMagicNumber,	0 );
   
 	for ( int z = 0;  z < _OrdersTotal;  z ++ )
 	{
		if ( !OrderSelect( z, SELECT_BY_POS ) )
		{
			_GetLastError = GetLastError();
			Print("OrderSelect( ", z, ", SELECT_BY_POS ) - Error #", _GetLastError );
			continue;
		}
      if (magic == 0)
      {
		 if (OrderSymbol() == Symbol() )
		 {
			//    ,  
			_OrderTicket [_ExpertOrdersTotal] = OrderTicket();
 			_ExpertOrdersTotal ++;
 	   	switch(OrderType())
           {
            case OP_BUY       : _ExpertOrdersBuy++ ;        break; 
            case OP_SELL      : _ExpertOrdersSell++ ;       break;
            case OP_BUYSTOP   : _ExpertOrdersBuyStop++ ;    break;
            case OP_SELLSTOP  : _ExpertOrdersSellStop++ ;   break;
            case OP_BUYLIMIT  : _ExpertOrdersBuyLimit++ ;   break;
            case OP_SELLLIMIT : _ExpertOrdersSellLimit++ ;  break;
           }
		 } // if (OrderSymbol() == Symbol() )
		}  // if (magic == 0)
		else
		if (OrderMagicNumber() == magic && OrderSymbol() == Symbol() )
      {
		 {
			//    ,  
			_OrderTicket [_ExpertOrdersTotal] = OrderTicket();
 			_ExpertOrdersTotal ++;
 	   	switch(OrderType())
           {
            case OP_BUY       : _ExpertOrdersBuy++ ;        break; 
            case OP_SELL      : _ExpertOrdersSell++ ;       break;
            case OP_BUYSTOP   : _ExpertOrdersBuyStop++ ;    break;
            case OP_SELLSTOP  : _ExpertOrdersSellStop++ ;   break;
            case OP_BUYLIMIT  : _ExpertOrdersBuyLimit++ ;   break;
            case OP_SELLLIMIT : _ExpertOrdersSellLimit++ ;  break;
           }
		 } // if (OrderMagicNumber() == magic && OrderSymbol() == Symbol() )
		} // else
	} // for ( int z = 0;  z < _OrdersTotal;  z ++ )
	//     - ,   + 
	// ( _ExpertOrdersTotal = 0,     1)
	temp_value = MathMax( _ExpertOrdersTotal+1, 1 );
	ArrayResize( _OrderTicket,			temp_value );
	ArrayResize( _OrderType,			temp_value );
	ArrayResize( _OrderLots,			temp_value );
	ArrayResize( _OrderOpenPrice,		temp_value );
	ArrayResize( _OrderStopLoss,		temp_value );
	ArrayResize( _OrderTakeProfit,	temp_value );
	ArrayResize( _OrderOpenTime,		temp_value );
	ArrayResize( _OrderProfit,			temp_value );
	ArrayResize( _OrderSwap,			temp_value );
	ArrayResize( _OrderCommission,	temp_value );
	ArrayResize( _OrderComment,		temp_value );
	ArrayResize( _OrderExpiration,	temp_value );
	
	_OrderTicket[_ExpertOrdersTotal] = 99999999;//       
   ArraySort(_OrderTicket);  //   ...
//------------------------------------------------------------------------------------------------------------------------
	for (   z = 0;  z < _ExpertOrdersTotal;  z ++ )
 	{
		if ( !OrderSelect( _OrderTicket[z], SELECT_BY_TICKET ) )
		{
			_GetLastError = GetLastError();
			Print("OrderSelect( ", _OrderTicket[z], ", SELECT_BY_TICKET ) - Error #", _GetLastError );
			continue;
		}
 			//   
 			_OrderType			[z] = OrderType();
			_OrderLots			[z] = NormalizeDouble( OrderLots(), 2 );
			_OrderOpenPrice	[z] = NormalizeDouble( OrderOpenPrice(), Digits );
			_OrderStopLoss		[z] = NormalizeDouble( OrderStopLoss(), Digits );
			_OrderTakeProfit	[z] = NormalizeDouble( OrderTakeProfit(), Digits );
			_OrderOpenTime		[z] = OrderOpenTime();
			_OrderProfit		[z] = NormalizeDouble( OrderProfit(), 2 );
			_OrderSwap			[z] = NormalizeDouble( OrderSwap(), 2 );
			_OrderCommission	[z] = NormalizeDouble( OrderCommission(), 2 );
			_OrderComment		[z] = OrderComment();
			_OrderExpiration	[z] = OrderExpiration();
	      _OrderMagicNumber [z] = OrderMagicNumber();
			
  	}
//------------------------------------------------------------------------------------------------------------------------ 
return;	
} // AllOrdersInit( int magic )

//+------------------------------------------------------------------+
//|                                             ServiceFunctions.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
 //http://www.mql4.com/ru/users/bstone -  -  ,   
//+------------------------------------------------------------------+
//| helper functions   -                                         
//+------------------------------------------------------------------+

int sign( double v )
{
    if( v < 0 ) return( -1 );
    return( 1 );
}

//+------------------------------------------------------------------+
double iif( bool condition, double ifTrue, double ifFalse )
{
    if( condition ) return( ifTrue );
    
    return( ifFalse );
}

//+------------------------------------------------------------------+
string iifStr( bool condition, string ifTrue, string ifFalse )
{
    if( condition ) return( ifTrue );

    return( ifFalse );
}

//+------------------------------------------------------------------+
int orderDirection()
{
    return( 1 - 2 * ( OrderType() % 2 ) );
}
//------------------------------------------------------------------------------------------------------------------------   
   
 